program insext;

type
  instrument = record
    pm,pc,vm,vc,rm,rc,sm,sc,wm,wc,fm,rb1,rb2,rb3,rb4,rb5 : byte;
  end;

const
  default : instrument =
  (pm:$21;pc:$21;vm:$00;vc:$00;rm:$FF;rc:$FF;sm:$0F;sc:$0F;wm:$00;wc:$00;
  fm:$01;rb1:0;rb2:0;rb3:0;rb4:0;rb5:0);

var
  f,g : file;
  datrec : record
    pm,vm,rm,sm,wm,pc,vc,rc,sc,wc,fm : byte;
    res : array[0..35] of byte;
    num : byte;
  end;
  insrec : instrument;
  add : longint;
  nins : byte;
  i,j : longint;

begin
  assign(f,'C:\ULTIMA7\STATIC\U7INTRO.TIM');
  reset(f,1);
  assign(g,'LGD0.LGI');
  rewrite(g,1);
  seek(f,$88);
  blockread(f,add,4);
  seek(f,add);
  for i := 0 to 255 do blockwrite(g,default,16);
  blockread(f,nins,1);
  for j := 0 to nins-1 do begin
    blockread(f,datrec,48);
    insrec.pm := datrec.pm;
    insrec.pc := datrec.pc;
    insrec.vm := datrec.vm;
    insrec.vc := datrec.vc;
    insrec.rm := datrec.rm;
    insrec.rc := datrec.rc;
    insrec.sm := datrec.sm;
    insrec.sc := datrec.sc;
    insrec.wm := datrec.wm;
    insrec.wc := datrec.wc;
    insrec.fm := datrec.fm;
    insrec.rb1 := 0;
    insrec.rb2 := 0;
    insrec.rb3 := 0;
    insrec.rb4 := 0;
    insrec.rb5 := 0;
    i := datrec.num;
    seek(g,i*16);
    blockwrite(g,insrec,16);
  end;
end.