program linstall;

{$M 16384,0,0}
{$I-}

uses
  dos,
  crt;

type
  screentype = array[0..24,0..79] of record
    ch : char;
    at : byte;
  end;

var
  screen : screentype absolute $B800:$0000;
  scr1,scr2 : screentype;
  comd : string;
  s,dir0,dir : string;
  c : char;
  x1,y1,x2,y2 : byte;
  scrno : byte;

procedure scrn1;
begin
  if scrno=1 then exit;
  x2 := wherex;
  y2 := wherey;
  scr2 := screen;
  screen := scr1;
  gotoxy(x1,y1);
  scrno := 1;
end;

procedure scrn2;
begin
  if scrno=2 then exit;
  x1 := wherex;
  y1 := wherey;
  scr1 := screen;
  screen := scr2;
  gotoxy(x2,y2);
  scrno := 2;
end;

procedure stop(t : string);
begin
  scrn2;
  textattr := $07;
  writeln(t);
  halt;
end;

function ask(t : string) : boolean;
begin
  write(t:50);
  repeat
    c := readkey;
    c := upcase(c);
    if c=#27 then stop('Abandon provoqu par l''utilisateur.');
  until (c='O') or (c='N');
  writeln(c);
  ask := c='O';
end;

begin
  scrno := 2;
  scr2 := screen;
  x2 := wherex;
  y2 := wherey;
  scrn1;
  textattr := $4B;
  clrscr;
  comd := getenv('COMSPEC');
  if ioresult<>0 then stop('Erreur de lecture du DOS!');
  getdir(0,dir0);
  if (dir0[1]='A') or (dir0[1]='B') then begin
    writeln('* * *  I n s t a l l a t i o n  d e  L E G E N D E S  * * *');
    writeln;
    if not ask('Installer sur C:\LEGENDES? ') then begin
      write('Installer sur quel rpertoire? ':50);
      readln(dir);
    end else dir := 'C:\LEGENDES';
    chdir(dir);
    if ioresult<>0 then begin
      mkdir(dir);
      chdir(dir);
      if ioresult<>0 then stop('Erreur de cration du sous-rpertoire!');
    end;
    writeln('Copie de LEGENDES...');
    delay(3000);
    scrn2;
    s := dir0;
    if s[length(s)]<>'\' then s := s+'\';
    exec(comd,'/C COPY '+s+'*.*');
    scrn1;
    writeln('Extraction de LEGENDES...');
    delay(3000);
    scrn2;
    exec('PKUNZIP.EXE','LEGENDES');
    exec(comd,'/C DEL LEGENDES.ZIP');
    scrn1;
  end;
  stop('LEGENDES est install.');
end.