procedure livre(n : byte);

procedure livredemath(n : byte);
begin
  case n of
    1 : begin
      writeln;
      centrer('Chapitre I');
      centrer('Calcul numrique');
      justifie('     Il est commun lors des calculs numriques de faire ');
      justifie('appel  la notation dite dcimale introduite depuis ');
      justifie('longtemps au royaume de Sedneggel. Les chiffres sont ');
      justifie('0, 1, 2, 3, 4, 5, 6, 7, 8 et 9. Le premier sert galement ');
      justifie('comme marqueur de position: rajouter un 0  la fin d''un ');
      justifie('nombre le multiplie par 10. Ainsi 30 est dix fois 3. ');
      justifie('L''avantage principal du systme est de permettre ');
      justifie('d''ajouter, de soustraire, de multiplier et de diviser ');
      justifie('trs facilement. L''adition et la soustraction se font ');
      justifie('colonne par colonne, ainsi:');
      writeln;
      writeln('     * **      * ** ');
      writeln('     13646     42813');
      writeln('   + 29167   - 13646');
      writeln('   -------   -------');
      writeln('     42813     29167');
      justifie('Ces exemples mettent bien en lumire le role du report ');
      justifie('et de la retenue dans les oprations, ici reprsents ');
      justifie('par les astrisques ("*").');
      writeln;
      waitkey;
      justifie('     La multiplication peut se faire de deux manires: ');
      justifie(' la manire ancienne, on crit les deux nombres cte  ');
      justifie('cte, et  chaque ligne on divise le multiplicateur ');
      justifie('par deux tandis qu''on multiplie le multiplicande par ');
      justifie('deux. Puis on fait la somme de tous les multiplicandes ');
      justifie('ou le multiplicateur tait impair, ainsi:');
      writeln;
      writeln('*    613     201');
      writeln('    1226     100');
      writeln('    2452      50');
      writeln('*   4904      25');
      writeln('    9808      12');
      writeln('   19616       6');
      writeln('*  39232       3');
      writeln('*  78464       1');
      writeln('---------');
      writeln('  123213');
      waitkey;
      justifie('La nouvelle manire procde par produits partiels: ');
      justifie('on multiplie le multiplicande par chaque chiffre successif ');
      justifie('du multiplicateur, en dcalant les produits, que l''on ');
      justifie('ajoute enfin, ainsi:');
      writeln;
      writeln('     613');
      writeln('   x 201');
      writeln('   -----');
      writeln('     613');
      writeln('    000.');
      writeln('  1226..');
      writeln('  ------');
      writeln('  123213');
      justifie('La mthode sera choisie selon les nombres  multiplier.');
      writeln;
      waitkey;
      justifie('     La division se fait par approches successives: ');
      justifie('on part des quelques premiers chiffres du dividende, ');
      justifie('et on prend la valeur la plus grande possible pour ');
      justifie('en diviser par le diviseur. Le reste sera alors abaiss, ');
      justifie('ainsi que le chiffre suivant du dividende. Ainsi:');
      writeln;
      writeln('     123213  |  613');
      writeln('    -1226    +-----');
      writeln('     ----    |  201');
      writeln('        61   |');
      writeln('       - 0   |');
      writeln('        --   |');
      writeln('        613  |');
      writeln('       -613  |');
      writeln('        ---  |');
      writeln('          0  |');
      justifie('La division est dite exacte si son dernier reste est 0.');
      writeln;
    end;
    2 : begin
      writeln;
      centrer('Chapitre II');
      centrer('Calcul algbrique');
      justifie('     Le calcul algbrique consiste  remplacer les nombres ');
      justifie('par des lettres. Ainsi, a, b, c, etc. reprsenteront des ');
      justifie('nombres. a+b reprsente la somme des nombres a et b, ');
      justifie('a-b la diffrence, et ');
      justifie('a*b ou bien ab leur produit. Les parenthses, ( et ), ');
      justifie('servent  indiquer l''ordre dans lequel les oprations ');
      justifie('doivent tre poursuivies. S''il n''y an a pas, c''est ');
      justifie('le produit qui est considr comme prioritaire. ');
      justifie('Quand deux lettres ou bien deux expressions sont ');
      justifie('en fait le mme nombre, je place un signe = entre les ');
      justifie('deux. J''ai dcouvert les lois suivantes:');
      writeln;
      writeln('a-a  =  0');
      writeln('a+a  =  2a');
      writeln('a+a+a  =  3a');
      writeln('(etc.)');
      writeln('a(b+c)  =  ab + ac');
      writeln('(a+b)(c+d)  =  ac+bc+ad+bc');
      writeln('(a+b)(a+b)  =  aa+2ab+bb');
      writeln('(a-b)(a-b)  =  aa-2ab+bb');
      writeln('(a+b)(a-b)  =  aa-bb');
    end;
    3 : begin
      writeln;
      centrer('Chapitre III');
      centrer('Equations');
      justifie('     Les marchands trouveront sans doute tout cela ');
      justifie('trs utile. Une quation est un problme de trouver ');
      justifie('un nombre lorsqu''on a une condition sur ce nombre, ');
      justifie('ainsi "x-5=8" dtermine pour x la valeur 13, car 13-5=8. ');
      justifie('Un tel nombre est dit solution de l''quation.');
      writeln;
      justifie('     Les rgles sont: on peut ajouter ou soustraire ');
      justifie('entre elles les galits, les multiplier ou mme les ');
      justifie('diviser. Mais il faut toujours vrifier finalement que ');
      justifie('la valeur trouve marche. Ainsi:');
      writeln;
      waitkey;
      writeln('*** Premier exemple ***');
      writeln('x+y  =  12');
      writeln('x-y  =  4');
      writeln('x+x+y-y  =  16 (on ajoute)');
      writeln('2x  =  16 (car x+x=2x)');
      writeln('2  =  2');
      writeln('x  =  8 (on divise)');
      writeln('x+y-x  =  12-8 (on soustrait)');
      writeln('y  =  4');
      writeln('On vrifie: 8+4=12 et 8-4=4!');
      writeln('*** Second exemple ***');
      writeln('xy  =  40');
      writeln('x+y  =  13');
      writeln('(x+y)(x+y)  =  13 13 (on multiplie)');
      writeln('xx+2xy+yy  =  169');
      writeln('xx+2xy+yy-4xy  =  169-4 40 (on soustrait)');
      writeln('xx-2xy+yy  =  9');
      writeln('(x-y)(x-y)  =  3 3');
      writeln('x-y  =  3');
      writeln('2x  =  16 (comme avant)');
      writeln('x  =  8');
      writeln('y  =  5');
      writeln('On vrifie: 8+5=13 et 8 5=40!');
    end;
  end;
  waitkey;
end;

begin
  pushecr;
  window(1,1,80,25);
  textattr := $5E;
  clrscr;
  case n of
    1 : begin
      centrer('Mythologie abrge et lments de thologie');
      centrer('H. K. Halemina');
      centrer('Pantodies 31 fvrier 1086');
      justifie('     Le monde de Sedneggel a t cr par le Dmiurge ');
      justifie('sur la base des trois nergies primaires que l''on ');
      justifie('dsigne par les noms symboliques: Clavel, Madore et ');
      justifie('Pnet. Puis il divisa le monde en neuf Points ');
      justifie('Cardinaux:');
      writeln;
      writeln('Turgath':32,'Eramok':16,'Igonor':16);
      writeln('Nibua':32,'Terkel':16,'Nekol':16);
      writeln('Ayola':32,'Madena':16,'DEMIURGE':16);
      waitkey;
      justifie('     Se rservant ainsi le Cardinal Sud-Est, il cra ');
      justifie('huit autres dieux et donna  chacun un temple dans ');
      justifie('sa direction. Le sien mme n''est pas  l''extrme ');
      justifie('Sud-Est car il dsirait que celui qui le cherche ');
      justifie('le chercht vraiment. On dit mme parfois que son ');
      justifie('temple bouge de jour en jour. Les autres temples ');
      justifie('sont fixes. Chaque dieu incarne un principe suprme ');
      justifie('du Bien voulu par le Dmiurge: Turgath, la nuit, ');
      justifie('Eramok, le soleil, Igonor, le feu, Nibua, l''air, ');
      justifie('Terkel, l''Univers Cleste, Nekol, la terre, ');
      justifie('Ayola, l''eau, et Madena, la lune.');
      writeln;
      waitkey;
      justifie('     Ainsi base sur un quilibre parfait entre les ');
      justifie('lments et les forces principales de Clavel, Madore ');
      justifie('et Pnet, notre monde de Sedneggel est ternel et ');
      justifie('inattaquable. Il en sera ainsi de toute ternit!');
      writeln;
    end;
    2 : begin
      centrer('Gographie lmentaire');
      centrer('S. S. Stysisa');
      centrer('Davidi 3 aot 1710');
      justifie('     Notre pays est particulirement facile  comprendre ');
      justifie('en ce qui concerne la gographie physique: on peut ');
      justifie('principalement le diviser en trois bandes, du nord-est ');
      justifie('au sud-ouest. Au nord-est se trouvent les montagnes ');
      justifie('d''Arkenheim, ces hauts monts impntrables  la ');
      justifie('civilisation. C''est en leur coeur que l''on trouve ');
      justifie('le temple d''Igonor. Au sud-ouest, l''ocan occupe ');
      justifie('un bon quart du territoire. Seule deux les en meublent ');
      justifie('l''espace: l''le Panklorya et l''le Slina; la premire ');
      justifie('est l''espace le plus florissant du pays, et le sige ');
      justifie('de la rcemment construite Bybliothque, la seconde ');
      justifie('est le sige du temple de Madena. ');
      waitkey;
      justifie('Mais l''essentiel ');
      justifie('du pays est la bande centrale, qui s''tend du nord-est ');
      justifie('au sud-ouest. Elle est irrigue par le fleuve ');
      justifie('Toliandre et son affluent le Ngune, qui prennent ');
      justifie('leur source dans les lacs Amnoko et Nilia. Au nord-est ');
      justifie('se trouve le temple de Turgath, autrefois dieu de la nuit ');
      justifie('et  prsent Dieu Neutre. Tout prs se trouve la ville ');
      justifie('d''Arkillia la Neuve. Au centre du royaume, le palais ');
      justifie('royal, o sige notre bien-aim roi Ergewin II, ');
      justifie('prs de la capitale, Sedneggelia. Plus au sud, ');
      justifie('le port royal d''Hydropolis. A l''extrme sud-est, ');
      justifie('on trouve la ville de Dmiourpolia. Mais Sedneggel ');
      justifie('est galement fertile en petites villes et en villages ');
      justifie('aux noms enchanteurs.');
    end;
    3 : begin
      centrer('Le Livre des Prophties');
      centrer('J. R. Mapcla');
      centrer('Laurendi premier janvier 1');
      justifie('     Quelqu''un a fait une erreur quelque part. Le ver ');
      justifie('s''est introduit dans le fruit parfait qu''est Sedneggel. ');
      justifie('Les Energies se sont figes. Le Mal est venu au monde. ');
      justifie('Aujourd''hui il est encore imperceptible. Demain, il ');
      justifie('sera partout.');
      writeln;
      justifie('     Turgath est un des plus fidles serviteurs ');
      justifie('du Dmiurge. Mais ce dieu de la nuit va vouloir obscurcir ');
      justifie('le soleil. Il tendra ses tentacules de Mort vers Eramok ');
      justifie('et Nibua, vers le soleil et les thers.');
      writeln;
      waitkey;
      justifie('     Et, devenu Matre du Mal, Turgath accrotra sans cesse ');
      justifie('ses pouvoirs pendant un milllaire. Depuis l''an mil, ');
      justifie('sa corruption, d''abord latente, deviendra ensuite de plus ');
      justifie('en plus apparente, jusqu'' clater au grand jour. ');
      justifie('Progressivement, il s''appelera Dieu Neutre, puis ');
      justifie('Dieu du Mal ou Seigneur des Tnbres.');
      writeln;
      justifie('     Il lancera plusieurs assauts sur le monde. Un premier ');
      justifie('liminera les dieux mineurs, puis les Sept Grands, ');
      justifie('que de toute manire personne n''adorera plus. ');
      justifie('Son second assaut conqurera la Terre morceau par morceau ');
      justifie('en faisant tout tomber sur son passage.');
      writeln;
      waitkey;
      justifie('     Aprs la mort des plus grandes divinits, le Dmiurge, ');
      justifie('abandonn de tous ses fidles, mourra lui-mme et en l''an ');
      justifie('deux mil, les Dieux du Mal tendront sur toutes choses ');
      justifie('leur empire illimit; les habitants de Sedneggel ne seront ');
      justifie('plus que les esclaves de Turgath, le Seigneur Noir. ');
      justifie('Il existe cependant un moyen d''viter cela: si quelqu''un ');
      justifie('parvient  rapporter l''Orbe de l''Univers Cleste au ');
      justifie('Dmiurge Abandonn, il pourra reconqurir ses pouvoirs ');
      justifie('et le monde renatra de ses cendres, un monde meilleur ');
      justifie('qui ne sera pas dchir par la lutte ternelle entre ');
      justifie('le Bien et le Mal.');
      writeln;
      justifie('     J''exhorte ds aujourd''hui ce futur hros  ne pas ');
      justifie('cder  la tentation de rejoindre Turgath. Il est le ');
      justifie('seul espoir de Sedneggel!');
      writeln;
    end;
    4 : begin
      centrer('Le Livre des Mantras');
      centrer('Eramok');
      centrer('Turgadi 8 mai 945');
      justifie('     J''cris aujourd''hui pour viter l''oubli demain; ');
      justifie('chacun devrait connatre les mantras. J''ai choisi RA. ');
      justifie('Puis PYR, GE, NU, PLO, AHM, MA furent choisis. Mais je ne ');
      justifie('peux pas ici rvler le mantra choisi par Terkel. C''est ');
      justifie(' lui de parler.');
      writeln;
      justifie('     RA est la syllabe de la lumire et de la vrit qui ');
      justifie('clate au grand jour. PYR est la syllabe en ternelle ');
      justifie('combustion. GE voque le pilier maternel qu''est la ');
      justifie('terre. NU s''lve tranquillement jusqu'' la lune. ');
      justifie('PLO est la syllabe aquatique par excellence. AHM est ');
      justifie('le son de l''lvation jusqu''aux thers. Enfin, MA ');
      justifie('n''est pas explique par Turgath; il prtend qu''il ');
      justifie('s''agit des premires lettres d''un mot.');
      writeln;
    end;
    5 : begin
      centrer('Elments de mathmatiques');
      centrer('L. Relu');
      centrer('Anergedi 6 mars 1809');
      repeat
        writeln;
        centrer('Table des matires');
        autour('A -',' Calcul numrique');
        autour('B -',' Calcul algbrique');
        autour('C -',' Equations');
        autour('Q -',' Quitter');
        repeat
          c := readkey;
          c := upcase(c);
        until (c='Q') or (c=#27) or (c=^C) or ((c>='A') and (c<='C'));
        if (c='Q') or (c=#27) or (c=^C) then begin
          popecr;
          exit;
        end else livredemath(byte(c)-64);
      until false;
    end;
    else begin
      justifie('Ce livre n''existe pas encore! Comment avez-vous fait ');
      justifie('pour l''obtenir?');
      writeln;
    end;
  end;
  waitkey;
  popecr;
end;