CODE    SEGMENT WORD PUBLIC

        ASSUME  CS:CODE

        PUBLIC  PUTBAR

Y       EQU     WORD PTR [BP+10]
L       EQU     WORD PTR [BP+8]
C       EQU     BYTE PTR [BP+6]

PUTBAR  PROC    FAR

;INITIALISATION
        PUSH    BP
        MOV     BP,SP

;SELECTION DU SEGMENT DE LA MEMOIRE ECRAN
        MOV     AX,0A000h
        MOV     ES,AX

;CALCUL DE L'ADRESSE
        MOV     AX,Y
        MOV     BX,80d
        MUL     BX
        MOV     SI,AX

;NOMBRE D'ITERATIONS
        MOV     CX,L
        SHR     CX,1
        SHR     CX,1
        SHR     CX,1

;DONNEE INITIALE POUR LES PORTS
        MOV     DX,3CEh
        MOV     AX,0205h
        OUT     DX,AX

;S'IL N'Y A PAS 8 POINTS A TRACER
        CMP     CX,0
        JZ      APRESBOUCLE

;DEBUT BOUCLE
BOUCLE  LABEL   NEAR

;ECRITURE DE 8 POINTS
        MOV     AL,C
        MOV     ES:[SI],AL

;8 POINTS SUIVANTS
        INC     SI

;FIN BOUCLE
        LOOP    BOUCLE
APRESBOUCLE LABEL NEAR

;CALCUL DU MASQUE POUR LES DERNIERS POINTS (<8)
        MOV     BL,255
        MOV     CX,L
        NOT     CL
        AND     CL,7
        SHL     BL,CL

;LECTURE D'INITIALISATION DES LATCHES
        MOV     AL,ES:[SI]

;ENVOI DU MASQUE
        MOV     AH,BL
        MOV     AL,08h
        OUT     DX,AX

;ECRITURE DE LA COULEUR
        MOV     AL,C
        MOV     ES:[SI],AL

;REINITIALISATION DES REGISTRES
        MOV     AX,0005h
        OUT     DX,AX
        MOV     AX,0FF08h
        OUT     DX,AX

;QUITTE
        POP     BP
        RET     6

PUTBAR  ENDP

CODE    ENDS

        END
