CODE    SEGMENT WORD PUBLIC

        ASSUME  CS:CODE

        PUBLIC  PUTDOT

X       EQU     WORD PTR [BP+10]
Y       EQU     WORD PTR [BP+8]
C       EQU     BYTE PTR [BP+6]

PUTDOT  PROC    FAR

;INITIALISATION
        PUSH    BP
        MOV     BP,SP

;SI C>=16 ALORS ON QUITTE
        CMP     C,10h
        JAE     OUT_OF_PRC

;OBTIENT L'ADRESSE DANS SI
        MOV     AX,80d
        MUL     Y
        MOV     BX,X
        MOV     CL,3d
        SHR     BX,CL
        ADD     AX,BX
        MOV     SI,AX

;OBTIENT LE MASQUE A UTILISER
        MOV     AX,X
        NOT     AX
        AND     AX,07h
        MOV     CL,AL
        MOV     AX,0000000000000001b
        SHL     AX,CL
        MOV     BX,AX

;LIT ADRESSE
        MOV     AX,0A000h
        MOV     ES,AX
        MOV     AL,ES:[SI]

;ENVOIE LES DONNEES DANS LES PORTS
        MOV     DX,3CEh
        MOV     AX,0205h
        OUT     DX,AX
        MOV     AL,8d
        MOV     AH,BL
        OUT     DX,AX

;EXECUTE L'ECRITURE
        MOV     AL,C
        MOV     ES:[SI],AL

;RESTAURE LES PORTS AUX VALEURS STANDARD
        MOV     DX,3CEh
        MOV     AX,0005h
        OUT     DX,AX
        MOV     AX,0FF08h
        OUT     DX,AX

;QUITTE
OUT_OF_PRC:    
        POP     BP
        RET     6

PUTDOT  ENDP

CODE    ENDS

        END
