unit routines;

{$R-,S-,I-,E-,N-}
{$IFDEF DEBUG}
{$D+,L+}
{$ELSE}
{$D-,L-}
{$ENDIF}

interface

uses
  crt,
  dos,
  decl,
  ctunit;

procedure effet(n : longint);

function upcase(ch : char) : char;

procedure traitechaine(is : string;var os : string);

procedure autour(s1,s2 : string);

procedure justifie(s : string);

procedure centrer(s : string);

procedure waitkey;

function readkey : char;

procedure dessinduchar(n : byte;d : dessin);

procedure fondbrillant;

procedure setegapalette(p : egapalette);

procedure setvgapalette(num : byte;p : vgapalette);

procedure preparevgapalettes;

procedure selectpalette(num : byte;force : boolean);

procedure zedessins;

procedure setclk(inval : word);

procedure unprepare;

procedure jeufini;

procedure incpv(n : longint);

procedure incpm(n : longint);

function suivant(n : longint) : longint;

function evalue(p : personnage) : longint;

procedure calculeperbienmal;

function possede(o,ss : byte) : boolean;

function eqquant(o,ss : byte) : word;

procedure addequip(o,ss : byte);

procedure add0equip(o,ss : byte);

procedure addarme(o,ss : byte;dom : integer;maud : boolean;fr,it,dx : integer);

procedure addquant(o,ss : byte;q : word);

procedure subequip(o,ss : byte);

procedure decrisobjet(o : byte);

function passable(tx,ty : integer) : boolean;

function navigable(dir : integer) : boolean;

procedure malef(x,y : integer);

function malq(x,y : integer) : boolean;

procedure maladif;

procedure passetemps(dr : longint;dort : boolean);

procedure deplmonstres;

procedure graphmode;

procedure supermode;

procedure vgamode;

procedure dernpal;

procedure putdot(x,y : word;c : byte);

procedure putblock(x,y : word;var blk : block);

procedure putbigblock(x,y : word;var blk : block);

procedure putbar(y,l : word;c : byte);

procedure putsdot(x,y : longint;c : byte);

procedure putsblock(x,y : word;blk : sblock);

procedure putsbigblock(x,y : word;blk : sblock);

procedure putsbar(y,l : word;c : byte);

procedure putvdot(x,y : longint;c : byte);

procedure putvgablock(x,y : word;blk : sblock);

procedure clrscr;

procedure pushecr;

procedure popecr;

procedure mort(causemale,causefem : string);

procedure perdu;

procedure gagnevraiment;

procedure chargeico;

procedure chargesico;

procedure sbputout(reg,dat : byte);

procedure sbinitvoice(v : byte);

procedure sbinit;

procedure cleanupmusic;

procedure startnew(name : string);

procedure voicevolume(voice : byte);

procedure cut(v : byte);

procedure play(v,note : byte);

procedure reloadmus;

procedure sndassign(name : string);

procedure choixmus;

procedure mytimer;
interrupt;

implementation

{$I ROUTDIV.PAS}

{$I MALADIF.PAS}

{$I TEMPS.PAS}

{$I GRAPHICS.PAS}

{$I ECRANS.PAS}

{$I MORT.PAS}

{$I PERDGAGN.PAS}

{$I CHARGE.PAS}

{$I CHARGES.PAS}

{$I MUSIC.PAS}

{$I TIMER.PAS}

end.