program takecmf;

type
  instrument = record
    pm,pc,vm,vc,rm,rc,sm,sc,wm,wc,fm,rb1,rb2,rb3,rb4,rb5 : byte;
  end;

const
  default : instrument =
  (pm:$21;pc:$21;vm:$00;vc:$00;rm:$FF;rc:$FF;sm:$0F;sc:$0F;wm:$00;wc:$00;
  fm:$01;rb1:0;rb2:0;rb3:0;rb4:0;rb5:0);
  hstr : array[0..3] of char = 'MThd';
  tstr : array[0..3] of char = 'MTrk';

var
  f,g,h : file;
  insrec : instrument;
  i,j : longint;
  addr,noins,pulse : word;
  length : longint;
  _ : longint;
  w : word;
  b : byte;
  buf : array[0..32745] of byte;

begin
  assign(f,'D:\SB\PLAYCMF\STARFM.CMF');
  reset(f,1);
  assign(g,'CMF.MID');
  rewrite(g,1);
  assign(h,'CMF.LGI');
  rewrite(h,1);
  seek(f,$06);
  blockread(f,addr,2);
  seek(f,$24);
  blockread(f,noins,2);
  seek(f,addr);
  for i := 0 to noins-1 do begin
    blockread(f,insrec,16);
    blockwrite(h,insrec,16);
  end;
  for i := noins to 255 do blockwrite(h,default,16);
  close(h);
  seek(f,$08);
  blockread(f,addr,2);
  seek(f,$0A);
  blockread(f,pulse,2);
  length := filesize(f)-addr;
  blockwrite(g,hstr,4);
  _ := $06000000;
  blockwrite(g,_,4);
  w := $0000;
  blockwrite(g,w,2);
  w := $0100;
  blockwrite(g,w,2);
  b := hi(pulse);
  blockwrite(g,b,1);
  b := lo(pulse);
  blockwrite(g,b,1);
  blockwrite(g,tstr,4);
  for i := 0 to 3 do begin
    b := (length shr ((3-i)*8)) and $FF;
    blockwrite(g,b,1);
  end;
  seek(f,addr);
  blockread(f,buf,32746,w);
  blockwrite(g,buf,w);
end.