{$F+}
procedure mytimer;
var
  trk : byte;
  cur : word;
  b : byte;
  done : boolean;
  temp : real;
  t : longint;
procedure atrack;
begin
  repeat
    if snddels[trk]>0 then begin
      dec(snddels[trk],midispeed);
      exit;
    end;
    cur := sndtrk[trk];
    if sndbuf^[cur]>=$80 then begin
      sndcom[trk] := sndbuf^[cur];
      inc(cur);
    end;
    case sndcom[trk] of
      $80..$8F : begin
        voice := sndcom[trk] and $0F;
        if sndins[voice]>=0 then cut(voice);
        inc(cur,2);
      end;
      $90..$9F : begin
        voice := sndcom[trk] and $0F;
        if sndbuf^[cur+1]=0 then cut(voice) else begin
          sndntvol[voice] := sndbuf^[cur+1] shr 1;
          if sndins[voice]>=0 then begin
            if sb then voicevolume(voice);
            play(voice,sndbuf^[cur]);
          end;
        end;
        inc(cur,2);
      end;
      $B0..$BF : begin
        voice := sndcom[trk] and $0F;
        b := sndbuf^[cur];
        if b=7 then begin
          sndchvol[voice] := sndbuf^[cur+1] shr 1;
          if sb then voicevolume(voice);
          inc(cur,2);
        end else inc(cur,2);
      end;
      $C0..$CF : begin
        voice := sndcom[trk] and $0F;
        b := sndbuf^[cur];
        sndins[voice] := b;
        if (voice<9) and sb then begin
          sbputout($20+vtab[voice].m,instrs^[b].pm);
          sbputout($20+vtab[voice].p,instrs^[b].pc);
          sbputout($40+vtab[voice].m,instrs^[b].vm);
          sbputout($40+vtab[voice].p,instrs^[b].vc);
          sbputout($60+vtab[voice].m,instrs^[b].rm);
          sbputout($60+vtab[voice].p,instrs^[b].rc);
          sbputout($80+vtab[voice].m,instrs^[b].sm);
          sbputout($80+vtab[voice].p,instrs^[b].sc);
          sbputout($E0+vtab[voice].m,instrs^[b].wm);
          sbputout($E0+vtab[voice].p,instrs^[b].wc);
          sbputout($C0+voice,instrs^[b].fm);
        end;
        inc(cur);
      end;
      $E0..$EF : begin
        inc(cur,2);
      end;
      $FF : begin
        if sndbuf^[cur]=$2F then begin
          sndtrk[trk] := 0;
          exit;
        end
        else if sndbuf^[cur]=$51 then begin
          tempo := longint(sndbuf^[cur+2]) shl 16
            + longint(sndbuf^[cur+3]) shl 8
            + sndbuf^[cur+4];
          temp := tempo*1.193180/dtime*midispeed;
          setclk(trunc(temp));
        end;
        inc(cur);
        inc(cur,sndbuf^[cur]+1);
      end;
      else snderror('INVALID COMMAND!!!!!');
    end;
    t := sndbuf^[cur] and $7F;
    while sndbuf^[cur]>=$80 do begin
      inc(cur);
      t := t shl 7 or (sndbuf^[cur] and $7F);
    end;
    inc(snddels[trk],t);
    inc(cur);
    sndtrk[trk] := cur;
  until false;
end;
procedure arcenciel;
var
  b : byte;
begin
  inc(colcnt);
  if colcnt and $0F<>0 then exit;
  {0 = arc-en-ciel}
  b := (colcnt shr 4) and $FF;
  if b<64 then begin
    dernieres[0].r := 63;
    dernieres[0].g := b;
    dernieres[0].b := 0;
  end else if b<128 then begin
    dernieres[0].r := 127-b;
    dernieres[0].g := 63;
    dernieres[0].b := 0;
  end else if b<192 then begin
    dernieres[0].r := 0;
    dernieres[0].g := 191-b;
    dernieres[0].b := b-128;
  end else begin
    dernieres[0].r := b-192;
    dernieres[0].g := 0;
    dernieres[0].b := 255-b;
  end;
  {1 = rougeoyement}
  if b<128 then dernieres[1].r := b div 2
    else dernieres[1].r := (255-b) div 2;
  dernieres[1].g := 0;
  dernieres[1].b := 0;
  {2 = jauneoyement}
  dernieres[2].r := dernieres[1].r;
  dernieres[2].g := dernieres[1].r;
  dernieres[2].b := 0;
  {3 = verdoyement}
  dernieres[3].r := 0;
  dernieres[3].g := dernieres[1].r;
  dernieres[3].b := 0;
  {4 = bleueoyement}
  dernieres[4].r := 0;
  dernieres[4].g := 0;
  dernieres[4].b := dernieres[1].r;
  {5 = grisseoyement}
  dernieres[5].r := dernieres[1].r;
  dernieres[5].g := dernieres[1].r;
  dernieres[5].b := dernieres[1].r;
  {6 = feu}
  dernieres[6].r := 63;
  dernieres[6].g := dernieres[1].r;
  dernieres[6].b := 0;
  {7 = eau}
  dernieres[7].r := dernieres[1].r;
  dernieres[7].g := dernieres[1].r;
  dernieres[7].b := 63;
  dernpal;
end;
begin
  inline($FA);
  if music and not nosnd then begin
    done := true;
    for trk := 0 to 31 do done := done and (sndtrk[trk]=0);
    sndloaded := sndloaded and not done;
    if sndloaded then
      for trk := 0 to 31 do if sndtrk[trk]>0 then atrack;
  end;
  if not novga and not nopal then arcenciel;
  inc(clkcount,clkval);
  if clkcount>=$FFFF then begin
    inline($9C);
    oldtimer;
    dec(clkcount,$FFFF);
  end else port[$20] := $20;
  inline($FB);
end;
{$F-}