program viewvoc;

uses
  dos,
  crt;

var
  f : file;
  tab,tabo : array[0..799] of byte;
  i,j,k,l : longint;
  pos,stp : longint;
  w : word;
  z,zo : integer;
  regs : registers;
  c : char;

procedure putdot(x,y : word;c : byte);
begin
  regs.ah := $0C;
  regs.al := c;
  regs.cx := x;
  regs.dx := y;
  intr($10,regs);
end;

begin
  assign(f,'TEST.VOC');
  reset(f,1);
  seek(f,$14);
  blockread(f,w,2);
  pos := w;
  stp := 100;
  regs.ax := $005E;
  intr($10,regs);
  repeat
    seek(f,pos+6);
    zo := z;
    tabo := tab;
    blockread(f,tab,800,z);
    for i := 0 to 799 do begin
      if i<zo then putdot(i,255-tabo[i],0);
      if i<z then putdot(i,255-tab[i],15);
    end;
    c := readkey;
    case c of
      #32 : inc(pos);
      #08 : dec(pos);
      #00 : begin
        c := readkey;
        case c of
          #75 : if pos>stp then dec(pos,stp);
          #77 : inc(pos,stp);
          #72 : if pos>800 then dec(pos,800);
          #80 : inc(pos,800);
        end;
      end;
      '+' : inc(stp);
      '-' : if stp>0 then dec(stp);
      '*' : inc(stp,10);
      '/' : if stp>=10 then dec(stp,10);
    end;
  until (c=#27);
  textmode(co80);
end.