program editvoc;

uses
  dos,
  crt;

var
  f : file;
  tab,tabo : array[0..639] of byte;
  i,j,k,l : longint;
  pos,stp : longint;
  w : word;
  z,zo : integer;
  regs : registers;
  c : char;

procedure putdot(x,y : word;c : byte);
begin
  regs.ah := $0C;
  regs.al := c;
  regs.cx := x;
  regs.dx := y;
  intr($10,regs);
end;

begin
  assign(f,'TEST.VOC');
  reset(f,1);
  seek(f,$14);
  blockread(f,w,2);
  pos := w;
  stp := 100;
  regs.ax := $0012;
  intr($10,regs);
  regs.ax := $0000;
  intr($33,regs);
  regs.ax := $0001;
  intr($33,regs);
  repeat
    seek(f,pos+6);
    zo := z;
    tabo := tab;
    blockread(f,tab,640,z);
    regs.ax := $0002;
    intr($33,regs);
    for i := 0 to 639 do begin
      if i<zo then putdot(i,255-tabo[i],0);
      if i<z then putdot(i,255-tab[i],15);
    end;
    regs.ax := $0001;
    intr($33,regs);
    repeat
      regs.ax := $0003;
      intr($33,regs);
      if regs.bx and 1=1 then begin
        i := regs.cx;
        j := regs.dx;
        if j<256 then begin
          regs.ax := $0002;
          intr($33,regs);
          putdot(i,255-tab[i],0);
          tab[i] := 255-j;
          putdot(i,j,15);
          regs.ax := $0001;
          intr($33,regs);
        end;
      end;
      if regs.bx and 2=2 then begin
        for i := regs.cx-4 to regs.cx+3 do if (i>=0) and (i<z) then begin
          j := regs.dx;
          if j>=256 then j := 255;
          regs.ax := $0002;
          intr($33,regs);
          putdot(i,255-tab[i],0);
          tab[i] := 255-j;
          putdot(i,j,15);
          regs.ax := $0001;
          intr($33,regs);
        end;
      end;
    until keypressed;
    c := readkey;
    seek(f,pos+6);
    blockwrite(f,tab,z);
    case c of
      #32 : inc(pos);
      #08 : dec(pos);
      #00 : begin
        c := readkey;
        case c of
          #75 : if pos>stp then dec(pos,stp);
          #77 : inc(pos,stp);
          #72 : if pos>640 then dec(pos,640);
          #80 : inc(pos,640);
        end;
      end;
      '+' : inc(stp);
      '-' : if stp>0 then dec(stp);
      '*' : inc(stp,10);
      '/' : if stp>=10 then dec(stp,10);
    end;
  until (c=#27);
  textmode(co80);
end.