program fontedit;

uses
  crt,
  dos;

type
  ch_ = array[0..15] of byte;

var
  f : file;
  font,f2 : array[0..255] of ch_;
  s : array[0..9] of ch_;
  i,j,k,l,m,n : longint;
  ch,x,y : byte;
  io : word;
  regs : registers;
  c : char;

begin
  {$I-}
  assign(f,'FONT.EGA');
  reset(f,1);
  io := ioresult;
  if io=2 then begin
    rewrite(f,1);
    regs.ax := $1130;
    regs.bh := $06;
    intr($10,regs);
    move(ptr(regs.es,regs.bp)^,font,4096);
    blockwrite(f,font,4096);
    close(f);
    reset(f,1);
    io := ioresult;
  end;
  if io<>0 then begin
    writeln('Erreur code ',io,'!');
    halt(io);
  end;
  {$I+}
  blockread(f,font,4096);
  f2 := font;
  close(f);
  ch := 65;
  x := 0;
  y := 0;
  textattr := $1F;
  clrscr;
  repeat
    gotoxy(1,1);
    clreol;
    writeln('Caractre numro : ',ch,'.');
    clreol;
    if ch>=32 then
      writeln('Caractre        : ',char(ch),'.')
    else writeln('Caractre        : ^',char(ch+64),'.');
    for i := 0 to 15 do begin
      for j := 0 to 7 do begin
        if font[ch,i] and (1 shl (7-j))=0 then begin
          write(#250); write(#250);
        end else begin
          write(#222); write(#221);
        end;
      end;
      writeln;
    end;
    gotoxy(x*2+1,y+3);
    c := readkey;
    c := upcase(c);
    case c of
      #27 : halt;
      #00 : begin
        c := readkey;
        case c of
          #72 : y := (y-1) and $0F;
          #75 : x := (x-1) and $07;
          #77 : x := (x+1) and $07;
          #80 : y := (y+1) and $0F;
          #73 : dec(ch);
          #81 : inc(ch);
          #84..#93 : s[byte(c)-84] := font[ch];
          #59..#68 : font[ch] := s[byte(c)-59];
        end;
      end;
      ' ' : font[ch,y] := font[ch,y] xor (1 shl (7-x));
      'S' : begin
        rewrite(f,1);
        blockwrite(f,font,4096);
        close(f);
      end;
      'L' : begin
        reset(f,1);
        blockread(f,font,4096);
        close(f);
      end;
      'C' : for i := 0 to 15 do font[ch,i] := 0;
      '2' : font[ch] := f2[ch];
    end;
  until false;
end.