program iconedit;

uses
  dos,
  crt;

const
  mulfac = 4;

type
  small = array[0..7,0..7] of byte;
  big = array[0..15,0..15] of byte;

var
  regs : registers;
  f : file of small;
  g : file of big;
  s : small;
  b : big;
  n,i,j,k,l,m1x,m1y,m2x,m2y : longint;
  c : char;
  couleur : byte;
  size : boolean;

{$F+}
{$L PUTDOT}

procedure putdot(x,y : word;c : byte);
external;

{$F-}

procedure putit(b : big);
var
  k,l : byte;
  x,y : word;
begin
  for k := 0 to 15 do for l := 0 to 15 do begin
    for x := l*mulfac to l*mulfac+mulfac-1 do
for y := k*mulfac to k*mulfac+mulfac-1 do
      if b[k,l]<16 then
        putdot(x,y,b[k,l])
      else putdot(x,y,(x+y) shr 1 and 1 * 15);
    if (k=i) and (l=j) then begin
      for x := l*mulfac to l*mulfac+mulfac-1 do begin
        putdot(x,k*mulfac,15);
        putdot(x,k*mulfac+mulfac-1,14);
      end;
      for y := k*mulfac to k*mulfac+mulfac-1 do begin
        putdot(l*mulfac,y,13);
        putdot(l*mulfac+mulfac-1,y,12);
      end;
    end;
  end;
  for k := 0 to 15 do for l := 0 to 15 do putdot(l+170,k,b[k,l] and 15);
  for k := 0 to 15 do for l := 0 to 15 do
    putdot(l+196,k,b[k,l] and 15 + b[k,l] shr 4 * 15);
  if couleur<16 then
    for k := 0 to 15 do for l := 0 to 15 do putdot(l+222,k,couleur)
  else for k := 0 to 15 do for l := 0 to 15 do
    putdot(l+222,k,(k+l) shr 1 and 1 * 15);
end;

procedure putsmall(s : small);
var
  k,l : byte;
  x,y : word;
begin
  for k := 0 to 7 do for l := 0 to 7 do begin
    for x := l*mulfac to l*mulfac+mulfac-1 do
for y := k*mulfac to k*mulfac+mulfac-1 do
      if s[k,l]<16 then
        putdot(x,y,s[k,l])
      else putdot(x,y,(x+y) shr 1 and 1 * 15);
    if (k=i) and (l=j) then begin
      for x := l*mulfac to l*mulfac+mulfac-1 do begin
        putdot(x,k*mulfac,15);
        putdot(x,k*mulfac+mulfac-1,14);
      end;
      for y := k*mulfac to k*mulfac+mulfac-1 do begin
        putdot(l*mulfac,y,13);
        putdot(l*mulfac+mulfac-1,y,12);
      end;
    end;
  end;
  for k := 0 to 7 do for l := 0 to 7 do putdot(l+170,k,s[k,l] and 15);
  for k := 0 to 7 do for l := 0 to 7 do
    putdot(l+196,k,s[k,l] and 15 + s[k,l] shr 4 * 15);
  if couleur<16 then
    for k := 0 to 7 do for l := 0 to 7 do putdot(l+222,k,couleur)
  else for k := 0 to 7 do for l := 0 to 7 do
    putdot(l+222,k,(k+l) shr 1 and 1 * 15);
end;

begin
  regs.ax := $0010;
  intr($10,regs);
  n := 0;
  i := 0;
  j := 0;
  m1x := 0;
  m1y := 0;
  m2x := 15;
  m2y := 15;
  couleur := 0;
  assign(g,'BIG.ICO');
  reset(g);
  seek(g,n);
  read(g,b);
  assign(f,'SMALL.ICO');
  reset(f);
  seek(f,n);
  read(f,s);
  size := true;
  repeat
    if size then begin
      putit(b);
      c := readkey;
      c := upcase(c);
      case c of
        #27 : halt;
        #13 : b[i,j] := couleur;
        ^I : begin
          textattr := $00;
          clrscr;
          size := not size;
          seek(f,n);
          read(f,s);
          i := i div 2;
          j := j div 2;
          m1x := m1x div 2;
          m1y := m1y div 2;
          m2x := m2x div 2;
          m2y := m2y div 2;
        end;
        'S' : begin
          seek(g,n);
          write(g,b);
        end;
        'C' : for k := 0 to 15 do for l := 0 to 15 do b[k,l] := couleur;
        '+' : begin
          seek(f,n);
          read(f,s);
          seek(f,filesize(f));
          write(f,s);
          seek(f,n);
          seek(g,filesize(g));
          write(g,b);
          seek(g,n);
        end;
        '1' : begin
          m1x := i;
          m1y := j;
        end;
        '2' : begin
          m2x := i;
          m2y := j;
        end;
        'F' : begin
          for k := m1x to m2x do for l := m1x to m2y do
            b[k,l] := couleur;
        end;
        #00 : begin
          c := readkey;
          case c of
            #73 : if n>0 then begin
              dec(n);
              seek(g,n);
              read(g,b);
            end;
            #81 : if n<filesize(g)-1 then begin
              inc(n);
              seek(g,n);
              read(g,b);
            end;
            #72 : i := (i+15) and 15;
            #75 : j := (j+15) and 15;
            #77 : j := (j+1) and 15;
            #80 : i := (i+1) and 15;
            #59..#68 : couleur := (byte(c)-59);
            #84..#90 : couleur := (byte(c)-74);
          end;
        end;
      end;
    end else begin
      putsmall(s);
      c := readkey;
      c := upcase(c);
      case c of
        #27 : halt;
        #13 : s[i,j] := couleur;
        ^I : begin
          size := not size;
          seek(g,n);
          read(g,b);
          i := i*2;
          j := j*2;
          m1x := m1x*2;
          m1y := m1y*2;
          m2x := m2x*2;
          m2y := m2y*2;
        end;
        'S' : begin
          seek(f,n);
          write(f,s);
        end;
        'C' : for k := 0 to 7 do for l := 0 to 7 do s[k,l] := couleur;
        '+' : begin
          seek(f,filesize(f));
          write(f,s);
          seek(f,n);
          seek(g,n);
          read(g,b);
          seek(g,filesize(g));
          write(g,b);
          seek(g,n);
        end;
        '1' : begin
          m1x := i;
          m1y := j;
        end;
        '2' : begin
          m2x := i;
          m2y := j;
        end;
        'F' : begin
          for k := m1x to m2x do for l := m1x to m2y do
            b[k,l] := couleur;
        end;
        #00 : begin
          c := readkey;
          case c of
            #73 : if n>0 then begin
              dec(n);
              seek(f,n);
              read(f,s);
            end;
            #81 : if n<filesize(f)-1 then begin
              inc(n);
              seek(f,n);
              read(f,s);
            end;
            #72 : i := (i+7) and 7;
            #75 : j := (j+7) and 7;
            #77 : j := (j+1) and 7;
            #80 : i := (i+1) and 7;
            #59..#68 : couleur := (byte(c)-59);
            #84..#90 : couleur := (byte(c)-74);
          end;
        end;
      end;
    end;
  until false;
end.