procedure utiliser;

var
  hinaus : boolean;

procedure metanneau;
begin
  case per.equipt[i].sstype of
    0 : writeln('Et en plus il n''a aucun intrt!');
    1 : begin
      if per.sorts[33] then begin
        writeln('Vous tes dj confus...');
      end else begin
        writeln('Vous vous sentez confus...');
        per.sorts[33] := true;
        per.durees[33] := 0;
      end;
    end;
    2 : begin
      writeln('Vous ne sentez rien de notable...');
    end;
    3 : begin
      writeln('Vous vous sentez plus fort!');
      inc(per.frc,20);
    end;
    4 : begin
      writeln('Vous vous sentez plus intelligent!');
      inc(per.int,20);
    end;
    5 : begin
      writeln('Vous vous sentez plus habile!');
      inc(per.dex,20);
    end;
    6 : begin
      writeln('Vous vous sentez trs lger!');
      per.sorts[38] := true;
      per.durees[38] := 0;
    end;
    else writeln('Dsol, cet anneau n''a pas encore d''effet!');
  end;
end;

procedure retireanneau;
begin
  b1 := false;
  for j := 0 to per.nequipt-1 do with per.equipt[j] do
    if (i<>j) and (code=4) and (sstype=per.equipt[i].sstype)
    and portee then b1 := true;
  case per.equipt[i].sstype of
    0 : writeln('Comment avez-vous bien pu faire?');
    1 : begin
      if b1 then begin
        writeln('Votre confusion ne cesse pas...');
      end else begin
        writeln('Vous restez encore confus quelque temps...');
        per.durees[33] := 50;
      end;
    end;
    2 : begin
      writeln('Vous ne sentez toujours rien de notable...');
    end;
    3 : begin
      writeln('Vous vous sentez moins fort...');
      dec(per.frc,20);
    end;
    4 : begin
      writeln('Vous vous sentez moins intelligent...');
      dec(per.int,20);
    end;
    5 : begin
      writeln('Vous vous sentez moins habile...');
      dec(per.dex,20);
    end;
    6 : begin
      if b1 then begin
        writeln('Vous ne sentez rien de notable.');
      end else begin
        writeln('Vous vous sentez trs lourd!');
        per.sorts[38] := false;
      end;
    end;
  end;
end;

procedure porter;
var
  lpar : set of byte;
begin
  with per.equipt[i] do begin
    if portee then begin
      if maudite then begin
        if code>=32 then writeln('Impossible: elle est maudite!')
        else writeln('Impossible: il est maudit!');
        exit;
      end;
      for j := 0 to 19 do if per.corpus[j]=i then
        per.corpus[j] := -1;
      portee := false;
      if code>=32 then writeln('Retire') else writeln('Retir');
      if (code>=32) and (code<64) then begin
        if code<48 then dec(per.armdomtot,domm)
        else dec(per.armurdomtot,domm);
        dec(per.frc,bonfrc);
        dec(per.int,bonint);
        dec(per.dex,bondex);
      end else if code=4 then retireanneau;
    end else begin
      if code>=32 then lpar := parties[code]
      else if code=4 then begin
        if per.corpus[12]=-1 then lpar := [12] else lpar := [11];
      end;
      for j := 0 to 19 do if (per.corpus[j]>=0)
      and (j in lpar) then begin
        justifie('Impossible de porter ceci: ');
        justifie('vous portez dj ');
        justifie(singul[per.equipt[per.corpus[j]].code]+'!');
        exit;
      end;
      for j := 0 to 19 do if j in lpar then
        per.corpus[j] := i;
      portee := true;
      if maudite then begin
        if code>=32 then writeln('Malheur! Elle est maudite!')
        else writeln('Malheur! Il est maudit!');
      end else begin
        if code>=32 then writeln('Porte') else writeln('Port');
      end;
      if (code>=32) and (code<64) then begin
        if code<48 then inc(per.armdomtot,domm)
        else inc(per.armurdomtot,domm);
        inc(per.frc,bonfrc);
        inc(per.int,bonint);
        inc(per.dex,bondex);
      end else if code=4 then metanneau;
    end;
  end;
end;

procedure util_;
begin
  case per.equipt[i].code of
    0 : begin
      effet(20+random(4));
      writeln('Vous vous rgalez.');
      subequip(0,0);
      incpv(random(5));
      dec(per.faim,100000);
      if per.faim<0 then per.faim := 0;
      if not novoc then repeat until ctstatus=0;
    end;
    1 : begin
      case per.equipt[i].sstype of
        0 : begin
          effet(5);
          writeln('Une douleur atroce vous tord les entrailles!');
          j := random(12)*25;
          writeln('Vous perdez ',j,' points de vie!!!');
          dec(per.pv,j);
          if per.pv<=0 then begin
            writeln('Et vous en mourez!!!!!');
            if not novoc then repeat until ctstatus=0;
            waitkey;
            hinaus := true;
            window(1,1,80,25);
            mort('Empoisonn','Empoisonne');
            exit;
          end;
          subequip(1,0);
          if not novoc then repeat until ctstatus=0;
        end;
        1 : begin
          writeln('Vous vous sentez mieux soudain!');
          per.pv := per.pvm;
          subequip(1,1);
        end;
        2 : begin
          writeln('Vous sentez l''nergie de la potion se dissoudre en vous!');
          per.pm := per.pmm;
          subequip(1,2);
        end;
        3 : begin
          writeln('Fiat lux, et lux fit!');
          per.sorts[14] := true;
          if per.durees[14]<25 then per.durees[14] := 25;
          subequip(1,3);
        end;
        4 : begin
          writeln('Vos yeux soudain voient mieux!');
          per.sorts[11] := true;
          if per.durees[11]<25 then per.durees[11] := 25;
          subequip(1,4);
        end;
        5 : begin
          writeln('Vous ne sentez aucun effet.');
          inc(per.exp,250);
          subequip(1,5);
        end;
        6 : begin
          writeln('Vous vous sentez tout neuf!');
          inc(per.frc,random(3));
          inc(per.int,random(3));
          inc(per.dex,random(3));
          subequip(1,6);
        end;
        7 : begin
          justifie('Aussitt que vous dbouchez la bouteille, elle se ');
          justifie('divise miraculeusement en sept petites.');
          for j := 0 to 6 do addequip(1,j);
          subequip(1,7);
        end;
        8 : begin
          if per.malad=0 then begin
            writeln('Vous ne sentez rien.');
          end else begin
            writeln('Vous tes guri!');
            per.malad := 0;
          end;
          subequip(1,8);
        end;
        else begin
          writeln('Dsol, cette potion n''a pas encore d''effet.');
        end;
      end;
    end;
    2 : begin
      livre(per.equipt[i].sstype);
      window(1,19,80,25);
      textattr := $1F;
      clrscr;
      writeln('C''tait passionnant, j''espre?');
    end;
    3 : begin
      if per.equipt[i].charges=0 then writeln('Elle est casse!')
      else begin
        case per.equipt[i].sstype of
          3 : begin
            if dansmu then begin
              writeln('Rien ne se passe.');
            end else begin
              justifie('Vous vous sentez attir par quelque chose ');
              if demix<=posx-10 then begin
                if demiy<=posy-10 then justifie('au nord-ouest ')
                else if demiy>=posy+10 then justifie('au sud-ouest ')
                else justifie(' l''ouest ');
              end else if demix>=posx+10 then begin
                if demiy<=posy-10 then justifie('au nord-est ')
                else if demiy>=posy+10 then justifie('au sud-est ')
                else justifie(' l''est ');
              end else begin
                if demiy<=posy-10 then justifie('au nord ')
                else if demiy>=posy+10 then justifie('au sud ')
                else justifie('tout prs ');
              end;
              justifie('d''ici.');
            end;
          end;
          4 : begin
            if xcombat and jetdesorts and (adv.pm>400) then begin
              writeln('Votre adversaire lance un contre-sort!');
              dec(adv.pm,400);
            end else begin
              writeln('Votre adversaire est pulvris!!!');
              adv.pv := 0;
            end;
            if not xcombat then
              writeln('Dommage! Il n''y avait qu''une mouche!');
          end;
          else writeln('Pas encore d''effet...');
        end;
        if per.equipt[i].charges>0 then dec(per.equipt[i].charges);
      end;
    end;
    4 : porter;
    5 : begin
      writeln('L''orbe du soleil se met  briller...');
      per.sorts[5] := true;
    end;
    6 : begin
      writeln('L''orbe de la lune se met  vous protger...');
      per.sorts[6] := true;
    end;
    7 : begin
      writeln('L''orbe de l''eau vous apprend  nager...');
      per.sorts[7] := true;
    end;
    8 : begin
      writeln('L''orbe du feu enflamme vos armes...');
      if not per.sorts[8] then
        per.armdomtot := per.armdomtot*2;
      per.sorts[8] := true;
    end;
    9 : begin
      writeln('L''orbe de la terre enduit vos armures de pierre...');
      if not per.sorts[9] then
        per.armurdomtot := per.armurdomtot*2;
      per.sorts[9] := true;
    end;
    10 : begin
      writeln('L''orbe de l''air vous apprend  survoler les montagnes...');
      per.sorts[10] := true;
    end;
    11 : begin
      writeln('Cette orbe est trop puissante pour vous!');
    end;
    12 : begin
      writeln('Allez voir une porte!');
    end;
    32..63 : porter;
  end;
  waitkey;
  if xcombat then hinaus := true;
end;

begin
  textattr := $1F;
  clrscr;
  writeln('Equipement : ');
  hinaus := false;
  l := 0;
  repeat
    if per.nequipt<>0 then begin
      while l<0 do inc(l,per.nequipt);
      while l>=per.nequipt do dec(l,per.nequipt);
    end;
    window(1,2,80,18);
    if not noega then textattr := $F0 else textattr := $70;
    clrscr;
    if per.nequipt=0 then begin
      writeln('--- NEANT ---');
      waitkey;
      window(1,1,80,25);
      exit;
    end;
    m := 0;
    if m<l-8 then m := l-8;
    n := per.nequipt-1;
    if n>m+15 then n := m+15;
    for i := m to n do begin
      if i=l then write('--> ') else write('    ');
      decrisobjet(i);
      writeln;
    end;
    c := readkey;
    c := upcase(c);
    if c=#00 then begin
      case skey of
        #72 : dec(l);
        #80 : inc(l);
      end;
    end else if c=#13 then begin
      i := l;
      window(1,19,80,25);
      textattr := $1F;
      util_;
      clrscr;
    end else if (c='Q') or (c=#27) or (c=^C) then hinaus := true;
  until hinaus;
  window(1,1,80,25);
end;